#!/usr/bin/env rexx


  -- make sure we change to the directory this program resides, such that all resources are in the local directory
parse source  . . pgm
call directory filespec('L', pgm)   -- change to the directory where the program resides

signal on syntax     -- in case something deep in Java caused an exception,

call bsf.loadClass "java.text.NumberFormat", "NumberFormat"
call bsf.loadClass "java.math.RoundingMode", "RoundingMode"
call bsf.loadClass "java.lang.Math",         "Math"

rxApp=.rexxApplication~new
   -- instantiate the abstract JavaFX class, abstract "start" method implemented in Rexx
jrxApp=BsfCreateRexxProxy(rxApp,,"javafx.application.Application")
   -- launch the application, which will invoke the methods "init" followed by "start"
jrxApp~launch(jrxApp~getClass, .nil)   -- need to use this version of launch in order to work
call sysSleep 0.01                     -- let ooRexx clean up
exit

syntax:
  co=condition("object")
  say ppJavaExceptionChain(co)   -- display Java exception chain
  exit -1

::requires "BSF.CLS"       -- get Java support

/* implements the abstract method "start" of javafx.application.Application */
::class RexxApplication

   /* loads the FXML file (doing translations), sets up a scene for it and shows it */
::method start  -- implementation in Rexx
  use arg primaryStage -- we get the primaryStage to use for our UI

  primaryStage~title="JavaFX Currency Converter (ooRexx)"
   -- create a file URL for CurrencyConverter.fxml file (hence the protocol "file:")
  fxmlUrl=.bsf~new("java.net.URL", "file:CurrencyConverter.fxml")
  rootNode=bsf.loadClass("javafx.fxml.FXMLLoader")~load(fxmlUrl)
  scene=.bsf~new("javafx.scene.Scene", rootNode)    -- create a scene from the tree
  primaryStage~setScene(scene)     -- set our scene on primaryStage
  primaryStage~setResizable(.false)-- do not allow the stage (window) to be resized
  primaryStage~show                -- show the primaryStage with the scene
